// file main.cpp
// author Edda Nourbakhsh


#include "../../MyMapDll/src/MyMap.h"


typedef MyMap * (*MapSignature)(char const * name);

int main(int argc, char* argv[])
{
	LPCTSTR mapPath("MyMapDll.dll");
	HINSTANCE hinstLib1;
	HINSTANCE hinstLib2;

	// Get a handle to the DLL module.
	if (hinstLib1 = LoadLibrary(mapPath))
	{
		MapSignature init3 = reinterpret_cast<MapSignature>(GetProcAddress(hinstLib1, "InitMap"));
		MyMap * pMyMap1 = init3("instance1");

		if (hinstLib2 = LoadLibrary(mapPath))
		{
			MapSignature init4 = reinterpret_cast<MapSignature>(::GetProcAddress(hinstLib2, "InitMap"));
			MyMap * pMyMap2 = init4("instance2");

			pMyMap1->log();
			pMyMap2->log();
		}
		else
		{
			FreeLibrary(hinstLib2);
		}
		FreeLibrary(hinstLib1);
	}
	else
	{
	}

	system("pause");

	return 0;
}
