// file My.cpp
// author Edda Nourbakhsh


#pragma once


#include <memory>
#include "My.h"


std::vector< std::shared_ptr < My > > My::mInstances;


My_API My * Init(char const * name)
{
  try
  {
    std::shared_ptr< My > sp;
    sp = std::make_shared< My >(name);
    My::mInstances.push_back(sp);

    return sp.get();

  }
  catch (...)
  {
    return nullptr;
  }
}
